Package: disdat
Type: Package
Title: Data for Comparing Species Distribution Modeling Methods
Version: 1.0-1
Date: 2023-02-07
Maintainer: Roozbeh Valavi <valavi.r@gmail.com>
License: GPL (>= 3)
Encoding: UTF-8
LazyLoad: yes
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, terra, sf, tmap, mapview
VignetteBuilder: knitr
NeedsCompilation: no
Authors@R: c(
	person("Robert J.", "Hijmans", role = "aut",  
			email = "r.hijmans@gmail.com", comment = c(ORCID = "0000-0001-5872-2872")),
    person("Roozbeh", "Valavi", role = c("cre", "aut"), email = "valavi.r@gmail.com"),
    person("Jane", "Elith",  role = "aut", email = "j.elith@gmail.com"))
Description: Easy access to species distribution data for 6 regions in the world, for a total of 226 anonymised species. These data are described and made available by Elith et al (2020) <doi:10.17161/bi.v15i2.13384> to compare species distribution modelling methods. 
Packaged: 2023-02-07 22:04:56 UTC; rvalavi
Author: Robert J. Hijmans [aut] (<https://orcid.org/0000-0001-5872-2872>),
  Roozbeh Valavi [cre, aut],
  Jane Elith [aut]
Repository: CRAN
Date/Publication: 2023-02-07 22:22:34 UTC
Built: R 4.3.3; ; 2025-01-24 06:40:15 UTC; unix

Package: disdat
Type: Package
Title: Data for Comparing Species Distribution Modeling Methods
Version: 1.1-0
Date: 2026-04-13
Maintainer: Roozbeh Valavi <valavi.r@gmail.com>
License: GPL (>= 3)
Encoding: UTF-8
LazyLoad: yes
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, terra, sf, tmap, mapview
VignetteBuilder: knitr
NeedsCompilation: no
Authors@R: c(
	person("Robert J.", "Hijmans", role = "aut",  
			email = "r.hijmans@gmail.com", comment = c(ORCID = "0000-0001-5872-2872")),
    person("Roozbeh", "Valavi", role = c("cre", "aut"), email = "valavi.r@gmail.com"),
    person("Jane", "Elith",  role = "aut", email = "j.elith@gmail.com"))
Description: Easy access to species distribution data for 6 regions in the world, for a total of 226 anonymised species. These data are described and made available by Elith et al (2020) <doi:10.17161/bi.v15i2.13384> to compare species distribution modelling methods. 
RoxygenNote: 7.3.3
Packaged: 2026-04-28 04:07:55 UTC; val085
Author: Robert J. Hijmans [aut] (ORCID:
    <https://orcid.org/0000-0001-5872-2872>),
  Roozbeh Valavi [cre, aut],
  Jane Elith [aut]
Repository: CRAN
Date/Publication: 2026-04-28 07:30:02 UTC
Built: R 4.5.2; ; 2026-04-28 10:53:05 UTC; unix

# Infrastructure

aws: Scripts for working with AWS resources such as S3 and EC2

kickstart: Scripts for creating linux and python environments.  Used for
Docker images. 

pythia: Database for storing bundles, lineage, and schemas. 

kubernetes: Facilities for starting, stopping, resizing kubernetes
clusters. 

Dockerfiles: Set of scripts to create Docker images. 

Requirements
------------
Docker

Instructions
------------
1. Build the protobuf 3.2.0 docker image

```bash
make protoc
```

2. Build the protobuf bundle message library

```bash
make bundle
```

3. Alternatively, build everything at once using

```bash
make
```

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, eval = FALSE, fig.align="center")

## ----eval=TRUE----------------------------------------------------------------
# install.packages('disdat')
# devtools::install_github('rspatial/disdat')
library(disdat)


## ----eval=TRUE, paged.print=TRUE----------------------------------------------
awt <- disBg("AWT")
head(awt)

## -----------------------------------------------------------------------------
#  library(GGally)
#  
#  ggcorr(awt[, 7:ncol(awt)],
#         method = c("pairwise", "spearman"),
#         label = TRUE,
#         label_size = 3,
#         label_color = "white",
#         digits = 2) +
#    theme(legend.justification = c(1, 0),
#          legend.position = c(0.5, 0.7),
#          legend.direction = "horizontal") +
#    guides(fill = guide_colorbar(barwidth = 9,
#                                 barheight = 1,
#                                 title.position = "top",
#                                 title.hjust = 0.5,
#                                 title = "Spearman correlation"))

## ---- eval=TRUE, out.width = 600, echo=F, fig.align="center"------------------
knitr::include_graphics("../man/figures/corr_plot.png")

## -----------------------------------------------------------------------------
#  library(ggplot2)
#  

## ----eval=TRUE----------------------------------------------------------------
# create density plot for species presence-only vs background data
# first prepare the species records in the right format for the tidyverse package:
po <- disPo("AWT") # presence-only data
bg <- disBg("AWT") # background data
spdata <- rbind(po, bg)
spdata$occ <- as.factor(spdata$occ)
levels(spdata$occ) <- c("Landscape", "Species")
levels(spdata$occ)


## -----------------------------------------------------------------------------
#  # now plot the data - specify the variable by its column name, as seen below in "aes(x = bc01,.....)"
#  ggplot(data = spdata, aes(x = bc01, fill = occ)) +
#    geom_density(alpha = 0.4) +
#    xlab("Annual mean temperature") +
#    scale_fill_brewer(palette = "Dark2") +
#    guides(fill = guide_legend(title = "")) +
#    theme_bw()
#  

## ---- eval=TRUE, out.width = 600, echo=F, fig.align="center"------------------
knitr::include_graphics("../man/figures/density_plot.png")

## -----------------------------------------------------------------------------
#  library(sf)
#  library(tidyverse)
#  
#  # presence-only data
#  awt_sf <- st_as_sf(disPo("AWT"), coords = c("x", "y"), crs = 28355)
#  
#  # a function to calculate the min distance (excluding self-distance)
#  mindist <- function(x) {
#    mindis <- vector(mode = "numeric", length = nrow(x))
#    for(i in 1:nrow(x)){
#      mindis[i] <- min(x[i, -i])
#    }
#    return(mindis)
#  }
#  
#  awt_min_dist <- awt_sf %>%
#    group_by(spid) %>%
#    nest() %>%
#    mutate(distM = map(data, ~st_distance(x = .)),
#           minDist = map(distM, ~mindist(x = .)),
#           meanDist = map_dbl(minDist, ~mean(x = .)))
#  

## ---- eval=TRUE, out.width = 400, echo=FALSE----------------------------------
knitr::include_graphics("../man/figures/boxplot.jpeg")

## -----------------------------------------------------------------------------
#  library(disdat)
#  library(sf)
#  library(tmap)
#  library(grid)
#  
#  # loading the data
#  r <- disBorder("NSW") # a polygon file showing border of the region
#  podata <- disPo("NSW") # presence-only data
#  padata <- disPa("NSW", "db") # presence-absence of group db for species 'nsw14'
#  
#  # select the species to plot
#  species <- "nsw14"
#  # convert the data.frame to sf objects for plotting
#  po <- st_as_sf(podata[podata$spid == species, ], coords = c("x", "y"), crs = 4326) # subset the species
#  pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)
#  
#  # create map showing training data
#  train_sample <- tm_shape(r) + # create tmap object
#    tm_polygons() + # add the border
#    tm_shape(po) + # create tmap object for the points to overlay
#    tm_dots(size = 0.2, col = "blue", alpha = 0.6, legend.show = FALSE) + # add the points
#    tm_compass(type = "8star", position = c("left", "top")) + # add north arrow
#    tm_layout(main.title = "Training data", main.title.position = "center") + # manage the layout
#    tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326, # add the grid
#            labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")})) # add degree symbol
#  
#  # create map showing testing data
#  pa[,species] <- as.factor(padata[,species])
#  test_sample <- tm_shape(r) +
#    tm_polygons() +
#    tm_shape(pa) +
#    tm_dots(species, size = 0.2, palette = c("red", "blue"), title = "Occurrence", alpha = 0.6) +
#    tm_layout(main.title = "Testing data", main.title.position = "center") +
#    tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326,
#            labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")}))
#  
#  # create a layout for putting the maps side-by-side
#  grid.newpage()
#  pushViewport(viewport(layout=grid.layout(1,2)))
#  print(train_sample, vp=viewport(layout.pos.col = 1))
#  print(test_sample, vp=viewport(layout.pos.col = 2))
#  

## ----eval=TRUE, echo=FALSE----------------------------------------------------
knitr::include_graphics("../man/figures/tmap.png")

## ----eval=TRUE, fig.height=5, fig.width=6, message=FALSE, warning=FALSE-------
library(mapview)
library(sf)

# get presence-absence data
padata <- disPa(region = "NSW", group = "db") 
# use disCRS for each region for its crs code (EPSG)
disCRS("NSW", format = "EPSG")
# convert the data.frame to sf objects for plotting
pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)
# select a species to plot
species <- "nsw14"

# plot presence-absence data
# you can add: map.types = "Esri.WorldImagery"
mapview(pa, zcol = species)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, eval = FALSE, fig.align="center")

## ----eval=TRUE----------------------------------------------------------------
# install.packages('disdat')
# devtools::install_github('rspatial/disdat')
library(disdat)


## ----eval=TRUE, paged.print=TRUE----------------------------------------------
awt <- disBg("AWT")
head(awt)

## -----------------------------------------------------------------------------
# library(GGally)
# 
# ggcorr(awt[, 7:ncol(awt)],
#        method = c("pairwise", "spearman"),
#        label = TRUE,
#        label_size = 3,
#        label_color = "white",
#        digits = 2) +
#   theme(legend.justification = c(1, 0),
#         legend.position = c(0.5, 0.7),
#         legend.direction = "horizontal") +
#   guides(fill = guide_colorbar(barwidth = 9,
#                                barheight = 1,
#                                title.position = "top",
#                                title.hjust = 0.5,
#                                title = "Spearman correlation"))

## ----eval=TRUE, out.width = 600, echo=F, fig.align="center"-------------------
knitr::include_graphics("../man/figures/corr_plot.png")

## -----------------------------------------------------------------------------
# library(ggplot2)
# 

## ----eval=TRUE----------------------------------------------------------------
# create density plot for species presence-only vs background data
# first prepare the species records in the right format for the tidyverse package:
po <- disPo("AWT") # presence-only data
bg <- disBg("AWT") # background data
spdata <- rbind(po, bg)
spdata$occ <- as.factor(spdata$occ)
levels(spdata$occ) <- c("Landscape", "Species")
levels(spdata$occ)


## -----------------------------------------------------------------------------
# # now plot the data - specify the variable by its column name, as seen below in "aes(x = bc01,.....)"
# ggplot(data = spdata, aes(x = bc01, fill = occ)) +
#   geom_density(alpha = 0.4) +
#   xlab("Annual mean temperature") +
#   scale_fill_brewer(palette = "Dark2") +
#   guides(fill = guide_legend(title = "")) +
#   theme_bw()
# 

## ----eval=TRUE, out.width = 600, echo=F, fig.align="center"-------------------
knitr::include_graphics("../man/figures/density_plot.png")

## -----------------------------------------------------------------------------
# library(sf)
# library(tidyverse)
# 
# # presence-only data
# awt_sf <- st_as_sf(disPo("AWT"), coords = c("x", "y"), crs = 28355)
# 
# # a function to calculate the min distance (excluding self-distance)
# mindist <- function(x) {
#   mindis <- vector(mode = "numeric", length = nrow(x))
#   for(i in 1:nrow(x)){
#     mindis[i] <- min(x[i, -i])
#   }
#   return(mindis)
# }
# 
# awt_min_dist <- awt_sf %>%
#   group_by(spid) %>%
#   nest() %>%
#   mutate(distM = map(data, ~st_distance(x = .)),
#          minDist = map(distM, ~mindist(x = .)),
#          meanDist = map_dbl(minDist, ~mean(x = .)))
# 

## ----eval=TRUE, out.width = 400, echo=FALSE-----------------------------------
knitr::include_graphics("../man/figures/boxplot.jpeg")

## -----------------------------------------------------------------------------
# library(disdat)
# library(sf)
# library(tmap)
# library(grid)
# 
# # loading the data
# r <- disBorder("NSW") # a polygon file showing border of the region
# podata <- disPo("NSW") # presence-only data
# padata <- disPa("NSW", "db") # presence-absence of group db for species 'nsw14'
# 
# # select the species to plot
# species <- "nsw14"
# # convert the data.frame to sf objects for plotting
# po <- st_as_sf(podata[podata$spid == species, ], coords = c("x", "y"), crs = 4326) # subset the species
# pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)
# 
# # create map showing training data
# train_sample <- tm_shape(r) + # create tmap object
#   tm_polygons() + # add the border
#   tm_shape(po) + # create tmap object for the points to overlay
#   tm_dots(size = 0.2, col = "blue", alpha = 0.6, legend.show = FALSE) + # add the points
#   tm_compass(type = "8star", position = c("left", "top")) + # add north arrow
#   tm_layout(main.title = "Training data", main.title.position = "center") + # manage the layout
#   tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326, # add the grid
#           labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")})) # add degree symbol
# 
# # create map showing testing data
# pa[,species] <- as.factor(padata[,species])
# test_sample <- tm_shape(r) +
#   tm_polygons() +
#   tm_shape(pa) +
#   tm_dots(species, size = 0.2, palette = c("red", "blue"), title = "Occurrence", alpha = 0.6) +
#   tm_layout(main.title = "Testing data", main.title.position = "center") +
#   tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326,
#           labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")}))
# 
# # create a layout for putting the maps side-by-side
# grid.newpage()
# pushViewport(viewport(layout=grid.layout(1,2)))
# print(train_sample, vp=viewport(layout.pos.col = 1))
# print(test_sample, vp=viewport(layout.pos.col = 2))
# 

## ----eval=TRUE, echo=FALSE----------------------------------------------------
knitr::include_graphics("../man/figures/tmap.png")

## ----eval=TRUE, fig.height=5, fig.width=6, message=FALSE, warning=FALSE-------
library(mapview)
library(sf)

# get presence-absence data
padata <- disPa(region = "NSW", group = "db") 
# use disCRS for each region for its crs code (EPSG)
disCRS("NSW", format = "EPSG")
# convert the data.frame to sf objects for plotting
pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)
# select a species to plot
species <- "nsw14"

# plot presence-absence data
# you can add: map.types = "Esri.WorldImagery"
mapview(pa, zcol = species)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, tidy = TRUE, tidy.opts=list(width.cutoff=80))

## ---- out.width = 600, echo=F, fig.align="center"-----------------------------
knitr::include_graphics("../man/figures/mapbook_eg.png")

## ----eval=FALSE---------------------------------------------------------------
#  # loading the library
#  library(disdat)
#  library(forcats) # for handling factor variables
#  library(randomForest)

## ----eval=FALSE---------------------------------------------------------------
#  # set output directory for prediction csv files:
#  outdir <- "~/Desktop/modeling_nceas"
#  # provide names for regions to be modeled - here we model all 6:
#  regions <- c("AWT", "CAN", "NSW", "NZ", "SA", "SWI")
#  # specify names of all categorical variables across all regions:
#  categoricalvars <- c("ontveg", "vegsys", "toxicats", "age", "calc")
#  
#  # check the model's output directory
#  if(file.exists(outdir)){
#    print("The directory already exists!")
#  } else{
#    dir.create(file.path(outdir))
#    print("The directory is created.")
#  }

## ----eval=FALSE---------------------------------------------------------------
#  n <- 0
#  for(r in regions){
#    # reading presence-only and background species data for this region, one file per region:
#    presences <- disPo(r)
#    background <- disBg(r)
#  
#    # extract names for all species
#    species <- unique(presences$spid)
#  
#    # now for each species, prepare data for modeling and evaluation
#    # with randomForests, model, predict to the evaluation file with
#    # environmental data.
#    for(s in species){
#      # subset presence records of species for this species
#      sp_presence <- presences[presences$spid == s, ]
#      # add background data
#      pr_bg <- rbind(sp_presence, background)
#  
#      # find the evaluation file – for some regions this means identifying the taxonomic group
#      if (r %in% c("AWT", "NSW")) {
#        grp <- sp_presence[, "group"][1]
#        evaluation <- disEnv(r, grp)
#      } else {
#        evaluation <- disEnv(r)
#      }
#  
#      # convert categorical vars to factor in both training and testing data. We use the package forcats to ensure that the levels of the factor in the evaluation data match those in the training data, regardless of whether all levels are present in the evaluation data.
#      for(i in 1:ncol(pr_bg)){
#        if(colnames(pr_bg)[i] %in% categoricalvars){
#          fac_col <- colnames(pr_bg)[i]
#          pr_bg[ ,fac_col] <- as.factor(pr_bg[ ,fac_col])
#          evaluation[ ,fac_col] <- as.factor(evaluation[ ,fac_col])
#          evaluation[ ,fac_col] <- forcats::fct_expand(evaluation[,fac_col], levels(pr_bg[,fac_col]))
#          evaluation[ ,fac_col] <- forcats::fct_relevel(evaluation[,fac_col], levels(pr_bg[,fac_col]))
#        }
#      }
#  
#      # extract the relevant columns for modelling
#      model_data <- pr_bg[, c("occ", disPredictors(r))]
#      # convert the response to factor for RF model to return probabilities
#      model_data$occ <- as.factor(model_data$occ)
#  
#      # start modeling! We use the "try" notation so if a species fails to fit, the loop will continue.
#      n <- n + 1
#      if(inherits(try(
#        mod <- randomForest(occ ~ ., data = model_data, ntree = 500)
#      ), "try-error")){print(paste("Error for species", s, "from", r))}
#  
#      # make and save the prediction
#      out_file <- evaluation[,1:3]
#      out_file$spid <- sp_presence$spid[1]
#      out_file$group <- sp_presence$group[1]
#      out_file$prediction <- predict(mod, evaluation, type = "prob")[,"1"] # prediction for presences
#      write.csv(out_file, paste(outdir, "/", r, "_", s, "_rf", ".csv", sep=""), row.names = FALSE)
#      print(n)
#    }
#  }
#  
#  

## ---- eval=FALSE--------------------------------------------------------------
#  library(dplyr)
#  library(ROCR)
#  
#  # specify the output folder that contains species predictions, and in which to save the models results
#  modelsdir <- "~/Desktop/modeling_nceas"
#  
#  # get the names of all the prediction files
#  sp_preds <- list.files(modelsdir, pattern = ".csv$", full.names = FALSE)
#  
#  # a data.frame to save the evaluation result
#  rf_eval <- data.frame(region = rep(NA, length(sp_preds)),
#                        species = NA,
#                        auc = NA)
#  
#  # now a loop to evaluate each species, one at a time:
#  n <- 0
#  for(i in sp_preds){
#    pred <- read.csv(file.path(modelsdir, i), stringsAsFactors = FALSE)
#    # get information on the species (s) and region (r) for each file:
#    r <- unlist(strsplit(i, "_"))[1]
#    s <- unlist(strsplit(i, "_"))[2]
#  
#    # now evaluate predictions, finding the right column for this species
#    # find the evaluation file – for some regions this means identifying the taxonomic group
#    if (r %in% c("AWT", "NSW")) {
#      grp <- pred[pred$spid == s, "group"][1]
#      evals <- disPa(r, grp)
#    } else {
#      evals <- disPa(r)
#    }
#  
#    n <- n + 1
#    perf <- prediction(pred$prediction, evals[, s]) %>%
#      performance("auc")
#    rf_eval$region[n] <- r
#    rf_eval$species[n] <- s
#    rf_eval$auc[n] <- as.numeric(perf@y.values)
#    print(s)
#  }
#  
#  mean(rf_eval$auc)
#  hist(rf_eval$auc)
#  
#  # auc mean for region
#  rf_eval %>%
#    group_by(region) %>%
#    summarise(mean(auc))
#  

## ----warning=F, message=F-----------------------------------------------------
library(terra)

## ----eval=F-------------------------------------------------------------------
#  po <- disPo("NSW")
#  nsw.raster <- rast("env_grids/nsw/mi.tif")

## ----message=F, eval=F, collapse=T--------------------------------------------
#  table(po$group)
#  target.groups <- list("bat"= "ba", "bird"= c("db", "nb"), "plant"= c("ot", "ou", "rt", "ru"), "reptile"= "sr")

## ----warning=F, message=F, eval=F---------------------------------------------
#  tgb.data <- list()
#  
#  for(i in 1:4){
#    getgroup <- match(po$group, target.groups[[i]])
#    dat <- po[!is.na(getgroup),]
#    samplecellID <- cellFromXY(nsw.raster,dat[,c("x","y")])
#    dup <- duplicated(samplecellID)
#    tgb.data[[i]] <- dat[!dup,]
#  }
#  
#  names(tgb.data) <- names(target.groups)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----out.width = 600, echo=F, fig.align="center"------------------------------
knitr::include_graphics("../man/figures/mapbook_eg.png")

## ----eval=FALSE---------------------------------------------------------------
# # loading the library
# library(disdat)
# library(forcats) # for handling factor variables
# library(randomForest)

## ----eval=FALSE---------------------------------------------------------------
# # set output directory for prediction csv files:
# outdir <- "~/Desktop/modeling_nceas"
# # provide names for regions to be modeled - here we model all 6:
# regions <- c("AWT", "CAN", "NSW", "NZ", "SA", "SWI")
# # specify names of all categorical variables across all regions:
# categoricalvars <- c("ontveg", "vegsys", "toxicats", "age", "calc")
# 
# # check the model's output directory
# if(file.exists(outdir)){
#   print("The directory already exists!")
# } else{
#   dir.create(file.path(outdir))
#   print("The directory is created.")
# }

## ----eval=FALSE---------------------------------------------------------------
# n <- 0
# for(r in regions){
#   # reading presence-only and background species data for this region, one file per region:
#   presences <- disPo(r)
#   background <- disBg(r)
# 
#   # extract names for all species
#   species <- unique(presences$spid)
# 
#   # now for each species, prepare data for modeling and evaluation
#   # with randomForests, model, predict to the evaluation file with
#   # environmental data.
#   for(s in species){
#     # subset presence records of species for this species
#     sp_presence <- presences[presences$spid == s, ]
#     # add background data
#     pr_bg <- rbind(sp_presence, background)
# 
#     # find the evaluation file – for some regions this means identifying the taxonomic group
#     if (r %in% c("AWT", "NSW")) {
#       grp <- sp_presence[, "group"][1]
#       evaluation <- disEnv(r, grp)
#     } else {
#       evaluation <- disEnv(r)
#     }
# 
#     # convert categorical vars to factor in both training and testing data. We use the package forcats to ensure that the levels of the factor in the evaluation data match those in the training data, regardless of whether all levels are present in the evaluation data.
#     for(i in 1:ncol(pr_bg)){
#       if(colnames(pr_bg)[i] %in% categoricalvars){
#         fac_col <- colnames(pr_bg)[i]
#         pr_bg[ ,fac_col] <- as.factor(pr_bg[ ,fac_col])
#         evaluation[ ,fac_col] <- as.factor(evaluation[ ,fac_col])
#         evaluation[ ,fac_col] <- forcats::fct_expand(evaluation[,fac_col], levels(pr_bg[,fac_col]))
#         evaluation[ ,fac_col] <- forcats::fct_relevel(evaluation[,fac_col], levels(pr_bg[,fac_col]))
#       }
#     }
# 
#     # extract the relevant columns for modelling
#     model_data <- pr_bg[, c("occ", disPredictors(r))]
#     # convert the response to factor for RF model to return probabilities
#     model_data$occ <- as.factor(model_data$occ)
# 
#     # start modeling! We use the "try" notation so if a species fails to fit, the loop will continue.
#     n <- n + 1
#     if(inherits(try(
#       mod <- randomForest(occ ~ ., data = model_data, ntree = 500)
#     ), "try-error")){print(paste("Error for species", s, "from", r))}
# 
#     # make and save the prediction
#     out_file <- evaluation[,1:3]
#     out_file$spid <- sp_presence$spid[1]
#     out_file$group <- sp_presence$group[1]
#     out_file$prediction <- predict(mod, evaluation, type = "prob")[,"1"] # prediction for presences
#     write.csv(out_file, paste(outdir, "/", r, "_", s, "_rf", ".csv", sep=""), row.names = FALSE)
#     print(n)
#   }
# }
# 
# 

## ----eval=FALSE---------------------------------------------------------------
# library(dplyr)
# library(ROCR)
# 
# # specify the output folder that contains species predictions, and in which to save the models results
# modelsdir <- "~/Desktop/modeling_nceas"
# 
# # get the names of all the prediction files
# sp_preds <- list.files(modelsdir, pattern = ".csv$", full.names = FALSE)
# 
# # a data.frame to save the evaluation result
# rf_eval <- data.frame(region = rep(NA, length(sp_preds)),
#                       species = NA,
#                       auc = NA)
# 
# # now a loop to evaluate each species, one at a time:
# n <- 0
# for(i in sp_preds){
#   pred <- read.csv(file.path(modelsdir, i), stringsAsFactors = FALSE)
#   # get information on the species (s) and region (r) for each file:
#   r <- unlist(strsplit(i, "_"))[1]
#   s <- unlist(strsplit(i, "_"))[2]
# 
#   # now evaluate predictions, finding the right column for this species
#   # find the evaluation file – for some regions this means identifying the taxonomic group
#   if (r %in% c("AWT", "NSW")) {
#     grp <- pred[pred$spid == s, "group"][1]
#     evals <- disPa(r, grp)
#   } else {
#     evals <- disPa(r)
#   }
# 
#   n <- n + 1
#   perf <- prediction(pred$prediction, evals[, s]) %>%
#     performance("auc")
#   rf_eval$region[n] <- r
#   rf_eval$species[n] <- s
#   rf_eval$auc[n] <- as.numeric(perf@y.values)
#   print(s)
# }
# 
# mean(rf_eval$auc)
# hist(rf_eval$auc)
# 
# # auc mean for region
# rf_eval %>%
#   group_by(region) %>%
#   summarise(mean(auc))
# 

## ----warning=F, message=F-----------------------------------------------------
library(terra)

## ----eval=F-------------------------------------------------------------------
# po <- disPo("NSW")
# nsw.raster <- rast("env_grids/nsw/mi.tif")

## ----message=F, eval=F, collapse=T--------------------------------------------
# table(po$group)
# target.groups <- list("bat"= "ba", "bird"= c("db", "nb"), "plant"= c("ot", "ou", "rt", "ru"), "reptile"= "sr")

## ----warning=F, message=F, eval=F---------------------------------------------
# tgb.data <- list()
# 
# for(i in 1:4){
#   getgroup <- match(po$group, target.groups[[i]])
#   dat <- po[!is.na(getgroup),]
#   samplecellID <- cellFromXY(nsw.raster,dat[,c("x","y")])
#   dup <- duplicated(samplecellID)
#   tgb.data[[i]] <- dat[!dup,]
# }
# 
# names(tgb.data) <- names(target.groups)

disBorder <- function(region, pkg="sf"){
	region <- .checkRegion(region)
	r <- tolower(region)
	path <- .pkgPath("borders")

	d <- file.path(path, paste0(r, ".gpkg"))
	if (pkg == "sf") {
		bor <- sf::st_read(d, quiet = TRUE)
	} else {
		bor <- terra::vect(d)
	}
	return(bor)
}


disPredictors <- function(region) {
	region <- .checkRegion(region)
	f <- file.path(.pkgPath(), paste0(region, "train_po.rds"))
	colnames(readRDS(f))[-c(1:6)]
}


disCRS <- function(region, format="proj4") {
	region <- .checkRegion(region)
	if (region=="AWT") {
		ifelse(format == "proj4",
		"+proj=utm +zone=55 +south +ellps=GRS80",
		"EPSG:28355")
	} else if (region=="CAN") {
		ifelse(format == "proj4",
		"+proj=longlat +ellps=clrk66",
		"EPSG:4008")
	} else if (region=="NZ") {
		ifelse (format=="proj4",
		"+proj=nzmg +lat_0=-41 +lon_0=173 +x_0=2510000 +y_0=6023150 +ellps=intl +towgs84=59.47,-5.04,187.44,0.47,-0.1,1.024,-4.5993 +units=m",
		"EPSG:27200")
	} else if (region=="SWI") {
	  ifelse (format=="proj4",
	          "+proj=tmerc +lat_0=46.95228333333333 +lon_0=7.439583333333333 +k=1 +x_0=600000 +y_0=200000 +ellps=bessel +units=m +no_defs",
	          "EPSG:21781")
	} else {
		ifelse (format=="proj4",
		"+proj=longlat +datum=WGS84",
		"EPSG:4326")
	}
}

# Author: Roozbeh Valavi
# contact: valavi.r@gmail.com
# Date : June 2020
# Version 0.2
# Licence GPL v3

disMapBook <- function(region, output_pdf, verbose = TRUE){

  regions <- unique(toupper(unlist(region)))
  if(regions[1] == 'ALL'){
    regions <- c('AWT', 'CAN', 'NSW', 'NZ', 'SA', 'SWI')
  }
  regions <- lapply(regions, .checkRegion)
  grDevices::pdf(output_pdf, width = 8.5, height = 10) # pdf setting
  for(r in regions){
    poly <- disBorder(r)
    presences <- disPo(r)
    # extract all species
    species <- unique(presences$spid)
    if(verbose){cat(paste(toupper(r), "has", length(species), "species\n"))}
    # reading evaluation files
    i <- 0
    graphics::par(mfrow=c(2,2))
    for(s in species){
      if (r %in% c("AWT", "NSW")) {
        grp <- presences[presences$spid == s, "group"][1]
        evaluation <- disPa(r, grp)
      } else {
        evaluation <- disPa(r)
      }
      i <- i + 1
      npres <- nrow(presences[presences$spid == s,])
      plot(sf::st_geometry(poly))
      graphics::points(presences[presences$spid == s, c("x", "y")],
                       pch = 16,
                       col = grDevices::rgb(0, 0, 255, maxColorValue = 255, alpha = 125))
      graphics::mtext(sprintf("Species: %s\nPresences: %s", s, npres))

      pres <- which(evaluation[,s] == 1)
      abse <- which(evaluation[,s] == 0)
      plot(sf::st_geometry(poly))
      graphics::points(evaluation[abse, c("x", "y")],
                       pch = 16,
                       col = grDevices::rgb(255, 0, 0, maxColorValue = 255, alpha = 50))
      graphics::points(evaluation[pres, c("x", "y")],
                       pch = 16,
                       col = grDevices::rgb(0, 0, 255, maxColorValue = 255, alpha = 50))
      graphics::mtext(sprintf("Species: %s\nPresences: %s Absences: %s", s, length(pres), length(abse)))

      if(verbose) cat(i, " ")
    }
    if(verbose) cat("\n")
  }
  grDevices::dev.off()
}

# Author: Robert J. Hijmans and Roozbeh Valavi
# contact: valavi.r@gmail.com
# Date : June 2020
# Version 0.1
# Licence GPL v3

.checkRegion <- function(region)  {
	regions <- c("AWT", "CAN", "NSW", "NZ", "SA", "SWI")
	region <- toupper(region[1])
	if (! region %in% regions) {
		stop("unknown region: ", region, ". Should be one of: ", paste(regions, collapse = ", "))
	}
	region
}

.pkgPath <- function(subdir="") {
	system.file(file.path("extdata", subdir), package="disdat")
}


.reshape_pa <- function(x) {
	r <- stats::reshape(x, varying=colnames(x)[-c(1:4)], times=colnames(x)[-c(1:4)], v.names="pa", timevar="spid", direction="long")
	r$id = NULL
	rownames(r) <- NULL
	r
}

disData <- function(region) {

	region <- .checkRegion(region)
	path <- .pkgPath()
	f <- list.files(pattern=region, path, full.names=TRUE)
	nms <- gsub("\\.rds", "", basename(f))
	nms <- gsub(region, "", nms)
	nms <- gsub("test_", "", nms)
	nms <- gsub("train_", "", nms)

	if (length(f) == 4) {
		x <- lapply(f, readRDS)
		names(x) <- nms
		i <- which(nms == "pa")
		x[[i]] <- .reshape_pa(x[[i]])
	} else {
		fe <- grep("_env", f, value=TRUE)
		env <- lapply(fe, readRDS)
		env <- do.call(rbind, env)

		fa <- grep("_pa", f, value=TRUE)
		pa <- lapply(fa, readRDS)
		pa <- lapply(pa, .reshape_pa)
		pa <- do.call(rbind, pa)

		bg <- readRDS(grep("train_bg", f, value=TRUE))
		po <- readRDS(grep("train_po", f, value=TRUE))
		x <- list(env=env, pa=pa, bg=bg, po=po)
	}
	return(x)
}


.getDisData <- function(region, dataset, type, group = NULL) {

	region <- .checkRegion(region)
	dataset <- tolower(dataset[1])
	type <- tolower(type[1])
	if(dataset == "train") {
		group <- NULL
	}
	.checkRegion(region)
	path <- .pkgPath()

	datasets <- c("train", "test")
	if (! dataset %in% datasets ) {
		stop("unknown dataset: ", dataset, ". Shoud be one of: ", paste(datasets, collapse = ", "))
	}
	if(dataset == "train" && ! type %in% c("po", "bg")){
		stop("unknown type for train dataset", ". Shoud be one of: ", paste(c("po", "bg"), collapse = ", "))
	}
	if(dataset == "test" && ! type %in% c("env", "pa")){
		stop("unknown type for test dataset", ". Shoud be one of: ", paste(c("pa", "env"), collapse = ", "))
	}
	if(region %in% c("AWT", "NSW") && dataset == "test" && is.null(group)){
		stop("You should specify a group for test dataset in AWT and NSW regions")
	}

	if(!is.null(group)){
		group <- tolower(group[1])
		groupAWT <- c("bird", "plant")
		if(region == "AWT" && ! group %in% groupAWT) {
			stop("unknown group for AWT region: ", group, ". Shoud be one of: ", paste(groupAWT, collapse = " "))
		}
		groupNSW <- c("ba", "db", "nb", "ot", "ou", "rt", "ru", "sr")
		if(region == "NSW" && ! group %in% groupNSW){
			stop("unknown group for NSW region: ", group, ". Shoud be one of: ", paste(groupNSW, collapse = " "))
		}
	}

	if(is.null(group)){
		x <- file.path(path, paste0(region, dataset, "_", type, ".rds"))
	} else{
		x <- file.path(path, paste0("/", region, dataset, "_", type, "_", group, ".rds"))
	}

	readRDS(x)
}



disPo <- function(region) { .getDisData(region, "train", "po") }
disBg <- function(region) { .getDisData(region, "train", "bg") }
disPa <- function(region, group = NULL) { .getDisData(region, "test", "pa", group) }
disEnv <- function(region, group = NULL) { .getDisData(region, "test", "env", group) }

---
title: "Data Visualisation for `disdat` data"
author: "Jane Elith and Roozbeh Valavi"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    fig_caption: yes
vignette: >
  %\VignetteIndexEntry{Data Visualisation for `disdat` data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, eval = FALSE, fig.align="center")
```

This document provides example code for understanding and visualising the NCEAS data within the  `disdat` package. This html file is created using R markdown. The code in the grey shaded areas that is not preceded by # can be copied and run in R. The code preceded by ## simply shows what the code above it returns. 

We need to load the `disdat` package first.

```{r  eval=TRUE}
# install.packages('disdat')
# devtools::install_github('rspatial/disdat')
library(disdat)

```


## Correlation matrix

Here is one example of how to create correlation matrices showing spearman rank correlation coefficients between all pairs of environmental variables. We use the AWT background data for our sample.

```{r eval=TRUE, paged.print=TRUE}
awt <- disBg("AWT")
head(awt)
```

Now we can create the correlation matrix for this dataset.

```{r}
library(GGally)

ggcorr(awt[, 7:ncol(awt)],
       method = c("pairwise", "spearman"),
       label = TRUE,
       label_size = 3,
       label_color = "white",
       digits = 2) +
  theme(legend.justification = c(1, 0),
        legend.position = c(0.5, 0.7),
        legend.direction = "horizontal") +
  guides(fill = guide_colorbar(barwidth = 9, 
                               barheight = 1, 
                               title.position = "top", 
                               title.hjust = 0.5, 
                               title = "Spearman correlation"))
```

```{r, eval=TRUE, out.width = 600, echo=F, fig.align="center"}
knitr::include_graphics("../man/figures/corr_plot.png")
``` 

## Density plots

This code shows how to create a density plot showing the density of records for species (one or many) vs that in the landscape, across one environmental variable in one region. We use all species in AWT across as an example. We plot density of records across variable "bc01", which is Annual mean temperature.

```{r}
library(ggplot2)

```

```{r eval=TRUE}
# create density plot for species presence-only vs background data
# first prepare the species records in the right format for the tidyverse package:
po <- disPo("AWT") # presence-only data
bg <- disBg("AWT") # background data
spdata <- rbind(po, bg)
spdata$occ <- as.factor(spdata$occ)
levels(spdata$occ) <- c("Landscape", "Species")
levels(spdata$occ)

```

```{r}
# now plot the data - specify the variable by its column name, as seen below in "aes(x = bc01,.....)"
ggplot(data = spdata, aes(x = bc01, fill = occ)) +
  geom_density(alpha = 0.4) +
  xlab("Annual mean temperature") +
  scale_fill_brewer(palette = "Dark2") +
  guides(fill = guide_legend(title = "")) +
  theme_bw()

```

```{r, eval=TRUE, out.width = 600, echo=F, fig.align="center"}
knitr::include_graphics("../man/figures/density_plot.png")
``` 

## Nearest-neighbour distance

You might be interested in distances between sites. There are various reasons for thinking about this, and various ways to calculate it. Here is one example, which simply asks: what is the **average nearest-neighbour distance** per species in each region, in the PO data. The distance is calculated in *metres*. This gives an indication of the clustering of sites in a region, which will be influenced by several things: density of sampling, biases in sampling (e.g. do recorders tend to go to the same general areas within the region), whether the selected species are spread throughout the region or clustered.   
    
Example code for calculating the mean nearest-neighbor distance for one region - here, we use AWT:

```{r}
library(sf)
library(tidyverse)

# presence-only data
awt_sf <- st_as_sf(disPo("AWT"), coords = c("x", "y"), crs = 28355)

# a function to calculate the min distance (excluding self-distance)
mindist <- function(x) {
  mindis <- vector(mode = "numeric", length = nrow(x))
  for(i in 1:nrow(x)){
    mindis[i] <- min(x[i, -i])
  }
  return(mindis)
}

awt_min_dist <- awt_sf %>% 
  group_by(spid) %>% 
  nest() %>% 
  mutate(distM = map(data, ~st_distance(x = .)),
         minDist = map(distM, ~mindist(x = .)),
         meanDist = map_dbl(minDist, ~mean(x = .)))

```

The code produces a “tibble”. You could, for instance, summarise the `meanDist` column: `summary(awt_min_dist$meanDist)`.

If you ran this code for all regions you could then create a figure like this:

```{r, eval=TRUE, out.width = 400, echo=FALSE}
knitr::include_graphics("../man/figures/boxplot.jpeg")
``` 

## Mapping species data
This code shows how to map the species presence-only and the evaluation presence-absence data. For doing this we use [tmap](https://github.com/mtennekes/tmap) and [mapview](https://github.com/r-spatial/mapview) packages.

### Plotting static map
We use tmap package to plot species data on one of the polygon borders.

```{r}
library(disdat)
library(sf)
library(tmap)
library(grid)

# loading the data
r <- disBorder("NSW") # a polygon file showing border of the region
podata <- disPo("NSW") # presence-only data
padata <- disPa("NSW", "db") # presence-absence of group db for species 'nsw14'

# select the species to plot
species <- "nsw14"
# convert the data.frame to sf objects for plotting
po <- st_as_sf(podata[podata$spid == species, ], coords = c("x", "y"), crs = 4326) # subset the species
pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)

# create map showing training data
train_sample <- tm_shape(r) + # create tmap object
  tm_polygons() + # add the border
  tm_shape(po) + # create tmap object for the points to overlay
  tm_dots(size = 0.2, col = "blue", alpha = 0.6, legend.show = FALSE) + # add the points
  tm_compass(type = "8star", position = c("left", "top")) + # add north arrow
  tm_layout(main.title = "Training data", main.title.position = "center") + # manage the layout
  tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326, # add the grid
          labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")})) # add degree symbol

# create map showing testing data
pa[,species] <- as.factor(padata[,species])
test_sample <- tm_shape(r) +
  tm_polygons() +
  tm_shape(pa) +
  tm_dots(species, size = 0.2, palette = c("red", "blue"), title = "Occurrence", alpha = 0.6) +
  tm_layout(main.title = "Testing data", main.title.position = "center") +
  tm_grid(lwd = 0.2, labels.inside.frame = FALSE, alpha = 0.4, projection = 4326,
          labels.format = list(big.mark = ",", fun = function(x){paste0(x, "º")}))

# create a layout for putting the maps side-by-side
grid.newpage()
pushViewport(viewport(layout=grid.layout(1,2)))
print(train_sample, vp=viewport(layout.pos.col = 1))
print(test_sample, vp=viewport(layout.pos.col = 2))

```

```{r eval=TRUE, echo=FALSE}
knitr::include_graphics("../man/figures/tmap.png")
``` 

We also provided code for creating a whole mapbook of all species data (training presences, and testing presence-absence) – see the `disMapBook` function.

### Plotting interactive map
To have a quick look at the data on an interactive session with satellite imagery background, you can use the **sf** object created in the previous section in a `mapview` function. You should be connected to the internet to see the background map. In the map below you should be able to zoom in and out and add different types of background information.

```{r eval=TRUE, fig.height=5, fig.width=6, message=FALSE, warning=FALSE}
library(mapview)
library(sf)

# get presence-absence data
padata <- disPa(region = "NSW", group = "db") 
# use disCRS for each region for its crs code (EPSG)
disCRS("NSW", format = "EPSG")
# convert the data.frame to sf objects for plotting
pa <- st_as_sf(padata, coords = c("x", "y"), crs = 4326)
# select a species to plot
species <- "nsw14"

# plot presence-absence data
# you can add: map.types = "Esri.WorldImagery"
mapview(pa, zcol = species)

```

---
title: "Modeling NCEAS data"
author: "Jane Elith and Roozbeh Valavi"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    fig_caption: yes
vignette: >
  %\VignetteIndexEntry{Modeling NCEAS data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
  
```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, tidy = TRUE, tidy.opts=list(width.cutoff=80))
```

## Introduction

The `disdat` package is primarily a data package, supplying the data described in Elith *et al.* (2020). There are data for 6 regions in the world, for a total of 226 anonymised species including birds, vascular plants, reptiles and bats. Each data set has presence-only (and optionally background) training data to build models, and presence/absence data to evaluate models. These data were compiled by a species distribution modeling working group sponsored by the National Center for Ecological Analysis and Synthesis (NCEAS), at UC Santa Barbara, USA (project ID: 4980). That group, or subsets of its members, have published 13 papers using some or all of the data for various explorations of model performance. Those papers are detailed in Elith *et al.* (2020). 

The data are now released both on Open Science Framework primarily as .csv files (link supplied in first reference, below) and here as an R package. Both sets of data are similar; in addition the OSF dataset includes raster files not supplied here (561MB zipped) and additional metadata files. Elith *et al.* (2020) detail the background to the data including suppliers, sources of both species and environmental data, steps for cleaning and preparation for modeling. Some of that information is also provided in the help files in this package, but note that Elith *et al.* (2020) provide the full documentation needed to understand the data.

Several functions are supplied, with help pages, in the `disdat` package, to load the data into your workspace or get it for modelling: `disPo`, `disBg`, `disPa`, `disEnv` and `disBorder`. The help files explain the nuances of these, and give examples of their application to load all data from all regions, or subsets of it. A function `disPredictors` returns the names of all predictor variables in the dataset and `disCRS` returns the information about coordinate reference system of each region.  

Finally, the function `disMapBook` enables you to generate maps, in PDF format, showing the location of PO and PA data for all species within one or more regions, with base plots looking like this:

```{r, out.width = 600, echo=F, fig.align="center"}
knitr::include_graphics("../man/figures/mapbook_eg.png")
``` 

In the remainder of this vignette we provide a few examples of how to model and evaluate using these data, and how to make your own target group background sample to help you to deal with biases in the data.

## Modeling all species with one modeling method - example

In this section, code is provided as an example of one approach for using these data for modeling and evaluation. Here we model all 226 species, using a random forest (RF) model with default settings. 

As you read the code you will notice two things:
1. for any one region and biological group, the evaluation data comes in two files: environmental data, that can be predicted to, and species data, for evaluating the predictions. 
2. that two regions (AWT and NSW) have more than one set of evaluation files, because there is more than one biological group (and therefore more than one set of surveys) for those regions. 
Both these points are explained in the help files for the data, and in Elith *et al.* (2020).

The way we organise the species data for modeling suits the `randomForest` package - each modeling method has different requirements. 

```{r eval=FALSE}
# loading the library
library(disdat) 
library(forcats) # for handling factor variables
library(randomForest)
```


Prepare for modeling:
```{r eval=FALSE}
# set output directory for prediction csv files:
outdir <- "~/Desktop/modeling_nceas"
# provide names for regions to be modeled - here we model all 6:
regions <- c("AWT", "CAN", "NSW", "NZ", "SA", "SWI")
# specify names of all categorical variables across all regions:
categoricalvars <- c("ontveg", "vegsys", "toxicats", "age", "calc")

# check the model's output directory
if(file.exists(outdir)){
  print("The directory already exists!")
} else{
  dir.create(file.path(outdir))
  print("The directory is created.")
}
```

Now start the modeling, working through one region at a time, getting the data for modeling and prediction, ensuring categorical predictors are represented correctly, and fitting a random forest model. **Note**: this is modelling all 226 species and will take some minutes to complete.

```{r eval=FALSE}
n <- 0
for(r in regions){
  # reading presence-only and background species data for this region, one file per region:
  presences <- disPo(r)
  background <- disBg(r)
  
  # extract names for all species
  species <- unique(presences$spid)
  
  # now for each species, prepare data for modeling and evaluation 
  # with randomForests, model, predict to the evaluation file with 
  # environmental data. 
  for(s in species){
    # subset presence records of species for this species
    sp_presence <- presences[presences$spid == s, ]
    # add background data
    pr_bg <- rbind(sp_presence, background)
    
    # find the evaluation file – for some regions this means identifying the taxonomic group
    if (r %in% c("AWT", "NSW")) {
      grp <- sp_presence[, "group"][1]
      evaluation <- disEnv(r, grp)
    } else {
      evaluation <- disEnv(r)
    }
    
    # convert categorical vars to factor in both training and testing data. We use the package forcats to ensure that the levels of the factor in the evaluation data match those in the training data, regardless of whether all levels are present in the evaluation data. 
    for(i in 1:ncol(pr_bg)){
      if(colnames(pr_bg)[i] %in% categoricalvars){
        fac_col <- colnames(pr_bg)[i]
        pr_bg[ ,fac_col] <- as.factor(pr_bg[ ,fac_col])
        evaluation[ ,fac_col] <- as.factor(evaluation[ ,fac_col])
        evaluation[ ,fac_col] <- forcats::fct_expand(evaluation[,fac_col], levels(pr_bg[,fac_col]))
        evaluation[ ,fac_col] <- forcats::fct_relevel(evaluation[,fac_col], levels(pr_bg[,fac_col]))
      }
    }
    
    # extract the relevant columns for modelling
    model_data <- pr_bg[, c("occ", disPredictors(r))]
    # convert the response to factor for RF model to return probabilities
    model_data$occ <- as.factor(model_data$occ)
    
    # start modeling! We use the "try" notation so if a species fails to fit, the loop will continue.
    n <- n + 1
    if(inherits(try(
      mod <- randomForest(occ ~ ., data = model_data, ntree = 500)
    ), "try-error")){print(paste("Error for species", s, "from", r))}
    
    # make and save the prediction
    out_file <- evaluation[,1:3]
    out_file$spid <- sp_presence$spid[1]
    out_file$group <- sp_presence$group[1]
    out_file$prediction <- predict(mod, evaluation, type = "prob")[,"1"] # prediction for presences
    write.csv(out_file, paste(outdir, "/", r, "_", s, "_rf", ".csv", sep=""), row.names = FALSE)
    print(n)
  }
}


```


## Evaluating the models

Here we give an example of evaluating the predictive performance of the model using area under the ROC curve (AUC). We get the predictions we have made, read in the relevant presence-absence observations, and evaluate the predictions. 

```{r, eval=FALSE}
library(dplyr)
library(ROCR)

# specify the output folder that contains species predictions, and in which to save the models results
modelsdir <- "~/Desktop/modeling_nceas"

# get the names of all the prediction files
sp_preds <- list.files(modelsdir, pattern = ".csv$", full.names = FALSE)

# a data.frame to save the evaluation result
rf_eval <- data.frame(region = rep(NA, length(sp_preds)), 
                      species = NA, 
                      auc = NA)

# now a loop to evaluate each species, one at a time:
n <- 0
for(i in sp_preds){
  pred <- read.csv(file.path(modelsdir, i), stringsAsFactors = FALSE)
  # get information on the species (s) and region (r) for each file:
  r <- unlist(strsplit(i, "_"))[1]
  s <- unlist(strsplit(i, "_"))[2]
  
  # now evaluate predictions, finding the right column for this species
  # find the evaluation file – for some regions this means identifying the taxonomic group
  if (r %in% c("AWT", "NSW")) {
    grp <- pred[pred$spid == s, "group"][1]
    evals <- disPa(r, grp)
  } else {
    evals <- disPa(r)
  }
  
  n <- n + 1
  perf <- prediction(pred$prediction, evals[, s]) %>% 
    performance("auc")
  rf_eval$region[n] <- r
  rf_eval$species[n] <- s
  rf_eval$auc[n] <- as.numeric(perf@y.values)
  print(s)
}

mean(rf_eval$auc)
hist(rf_eval$auc)

# auc mean for region
rf_eval %>% 
  group_by(region) %>% 
  summarise(mean(auc))

```


## Creating target group background (TGB) sample

### Introduction

This gives an example for one region, NSW, for creating target group background (TGB) samples. We chose NSW because it has several groups of species, so is one of the more complex examples. 

The main thing to understand here is that for TGB samples the intention is to create a sample consistent with protocols used for the presence records. So, for example, if you had cleaned presence records so there was only one record for each unique location, you would also screen the TGB samples in the same way. 

For these NCEAS data, the presence-only records were cleaned (per species) to one per grid cell. When making the TGB sample (e.g. for birds) a naïve approach would be to simply gather all the records for birds, and use those as a TGB sample. This would not be correct. You may have multiple records in any one cell (e.g. because a recorder may have gone to that location and recorded several species). The idea is to represent survey effort, and the survey effort is not a lot greater for recording many species at one location (or in this case, in one cell). Hence we will reduce the set of records for any designated "group" to one record per grid cell. 

To do this, you will need to download the rasters from OSF – see the link in the first reference below - see the /data/Environment folder. You can download all rasters at once by highlighting the "Environment" folder and clicking "Download as zip".

### TGB example

The code below assumes you have set your working directory, and the environmental rasters are in a sub-folder "env_grids", with the rasters for each region within their respective regional folders

Load the required packages:
```{r warning=F, message=F}
library(terra)
```

Read in the data for NSW:
```{r eval=F}
po <- disPo("NSW")
nsw.raster <- rast("env_grids/nsw/mi.tif")
```

Check how many groups and records in these PO data, and think about what target groups to propose. Here there are 8 groups (see main paper), but it is sensible to collapse some of these, given the way that recorders are likely to survey. Following Phillips *et al.* (2009) we propose four target groups: bat, bird, plant, reptile:

```{r message=F, eval=F, collapse=T}
table(po$group)
target.groups <- list("bat"= "ba", "bird"= c("db", "nb"), "plant"= c("ot", "ou", "rt", "ru"), "reptile"= "sr") 
```

Now, for each target group, extract the relevant rows of data, find which cell each record is in, then identify and remove the duplicates:
```{r warning=F, message=F, eval=F}
tgb.data <- list()

for(i in 1:4){
  getgroup <- match(po$group, target.groups[[i]])
  dat <- po[!is.na(getgroup),]
  samplecellID <- cellFromXY(nsw.raster,dat[,c("x","y")]) 
  dup <- duplicated(samplecellID)
  tgb.data[[i]] <- dat[!dup,]
}

names(tgb.data) <- names(target.groups)
```

## References
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E. (2020) Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics, 15, 69-80.

Phillips, S.J., Dudík, M., Elith, J., Graham, C.H., Lehmann, A., Leathwick, J. & Ferrier, S. (2009) Sample selection bias and presence-only distribution models: implications for background and pseudo-absence data. Ecological Applications, 19, 181–197.

---
title: "Modeling NCEAS data"
author: "Jane Elith and Roozbeh Valavi"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    fig_caption: yes
vignette: >
  %\VignetteIndexEntry{Modeling NCEAS data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
  
```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

## Introduction

The `disdat` package is primarily a data package, supplying the data described in Elith *et al.* (2020). There are data for 6 regions in the world, for a total of 226 anonymised species including birds, vascular plants, reptiles and bats. Each data set has presence-only (and optionally background) training data to build models, and presence/absence data to evaluate models. These data were compiled by a species distribution modeling working group sponsored by the National Center for Ecological Analysis and Synthesis (NCEAS), at UC Santa Barbara, USA (project ID: 4980). That group, or subsets of its members, have published 13 papers using some or all of the data for various explorations of model performance. Those papers are detailed in Elith *et al.* (2020). 

The data are now released both on Open Science Framework primarily as .csv files (link supplied in first reference, below) and here as an R package. Both sets of data are similar; in addition the OSF dataset includes raster files not supplied here (561MB zipped) and additional metadata files. Elith *et al.* (2020) detail the background to the data including suppliers, sources of both species and environmental data, steps for cleaning and preparation for modeling. Some of that information is also provided in the help files in this package, but note that Elith *et al.* (2020) provide the full documentation needed to understand the data.

Several functions are supplied, with help pages, in the `disdat` package, to load the data into your workspace or get it for modelling: `disPo`, `disBg`, `disPa`, `disEnv` and `disBorder`. The help files explain the nuances of these, and give examples of their application to load all data from all regions, or subsets of it. A function `disPredictors` returns the names of all predictor variables in the dataset and `disCRS` returns the information about coordinate reference system of each region.  

Finally, the function `disMapBook` enables you to generate maps, in PDF format, showing the location of PO and PA data for all species within one or more regions, with base plots looking like this:

```{r, out.width = 600, echo=F, fig.align="center"}
knitr::include_graphics("../man/figures/mapbook_eg.png")
``` 

In the remainder of this vignette we provide a few examples of how to model and evaluate using these data, and how to make your own target group background sample to help you to deal with biases in the data.

## Modeling all species with one modeling method - example

In this section, code is provided as an example of one approach for using these data for modeling and evaluation. Here we model all 226 species, using a random forest (RF) model with default settings. 

As you read the code you will notice two things:
1. for any one region and biological group, the evaluation data comes in two files: environmental data, that can be predicted to, and species data, for evaluating the predictions. 
2. that two regions (AWT and NSW) have more than one set of evaluation files, because there is more than one biological group (and therefore more than one set of surveys) for those regions. 
Both these points are explained in the help files for the data, and in Elith *et al.* (2020).

The way we organise the species data for modeling suits the `randomForest` package - each modeling method has different requirements. 

```{r eval=FALSE}
# loading the library
library(disdat) 
library(forcats) # for handling factor variables
library(randomForest)
```


Prepare for modeling:
```{r eval=FALSE}
# set output directory for prediction csv files:
outdir <- "~/Desktop/modeling_nceas"
# provide names for regions to be modeled - here we model all 6:
regions <- c("AWT", "CAN", "NSW", "NZ", "SA", "SWI")
# specify names of all categorical variables across all regions:
categoricalvars <- c("ontveg", "vegsys", "toxicats", "age", "calc")

# check the model's output directory
if(file.exists(outdir)){
  print("The directory already exists!")
} else{
  dir.create(file.path(outdir))
  print("The directory is created.")
}
```

Now start the modeling, working through one region at a time, getting the data for modeling and prediction, ensuring categorical predictors are represented correctly, and fitting a random forest model. **Note**: this is modelling all 226 species and will take some minutes to complete.

```{r eval=FALSE}
n <- 0
for(r in regions){
  # reading presence-only and background species data for this region, one file per region:
  presences <- disPo(r)
  background <- disBg(r)
  
  # extract names for all species
  species <- unique(presences$spid)
  
  # now for each species, prepare data for modeling and evaluation 
  # with randomForests, model, predict to the evaluation file with 
  # environmental data. 
  for(s in species){
    # subset presence records of species for this species
    sp_presence <- presences[presences$spid == s, ]
    # add background data
    pr_bg <- rbind(sp_presence, background)
    
    # find the evaluation file – for some regions this means identifying the taxonomic group
    if (r %in% c("AWT", "NSW")) {
      grp <- sp_presence[, "group"][1]
      evaluation <- disEnv(r, grp)
    } else {
      evaluation <- disEnv(r)
    }
    
    # convert categorical vars to factor in both training and testing data. We use the package forcats to ensure that the levels of the factor in the evaluation data match those in the training data, regardless of whether all levels are present in the evaluation data. 
    for(i in 1:ncol(pr_bg)){
      if(colnames(pr_bg)[i] %in% categoricalvars){
        fac_col <- colnames(pr_bg)[i]
        pr_bg[ ,fac_col] <- as.factor(pr_bg[ ,fac_col])
        evaluation[ ,fac_col] <- as.factor(evaluation[ ,fac_col])
        evaluation[ ,fac_col] <- forcats::fct_expand(evaluation[,fac_col], levels(pr_bg[,fac_col]))
        evaluation[ ,fac_col] <- forcats::fct_relevel(evaluation[,fac_col], levels(pr_bg[,fac_col]))
      }
    }
    
    # extract the relevant columns for modelling
    model_data <- pr_bg[, c("occ", disPredictors(r))]
    # convert the response to factor for RF model to return probabilities
    model_data$occ <- as.factor(model_data$occ)
    
    # start modeling! We use the "try" notation so if a species fails to fit, the loop will continue.
    n <- n + 1
    if(inherits(try(
      mod <- randomForest(occ ~ ., data = model_data, ntree = 500)
    ), "try-error")){print(paste("Error for species", s, "from", r))}
    
    # make and save the prediction
    out_file <- evaluation[,1:3]
    out_file$spid <- sp_presence$spid[1]
    out_file$group <- sp_presence$group[1]
    out_file$prediction <- predict(mod, evaluation, type = "prob")[,"1"] # prediction for presences
    write.csv(out_file, paste(outdir, "/", r, "_", s, "_rf", ".csv", sep=""), row.names = FALSE)
    print(n)
  }
}


```


## Evaluating the models

Here we give an example of evaluating the predictive performance of the model using area under the ROC curve (AUC). We get the predictions we have made, read in the relevant presence-absence observations, and evaluate the predictions. 

```{r, eval=FALSE}
library(dplyr)
library(ROCR)

# specify the output folder that contains species predictions, and in which to save the models results
modelsdir <- "~/Desktop/modeling_nceas"

# get the names of all the prediction files
sp_preds <- list.files(modelsdir, pattern = ".csv$", full.names = FALSE)

# a data.frame to save the evaluation result
rf_eval <- data.frame(region = rep(NA, length(sp_preds)), 
                      species = NA, 
                      auc = NA)

# now a loop to evaluate each species, one at a time:
n <- 0
for(i in sp_preds){
  pred <- read.csv(file.path(modelsdir, i), stringsAsFactors = FALSE)
  # get information on the species (s) and region (r) for each file:
  r <- unlist(strsplit(i, "_"))[1]
  s <- unlist(strsplit(i, "_"))[2]
  
  # now evaluate predictions, finding the right column for this species
  # find the evaluation file – for some regions this means identifying the taxonomic group
  if (r %in% c("AWT", "NSW")) {
    grp <- pred[pred$spid == s, "group"][1]
    evals <- disPa(r, grp)
  } else {
    evals <- disPa(r)
  }
  
  n <- n + 1
  perf <- prediction(pred$prediction, evals[, s]) %>% 
    performance("auc")
  rf_eval$region[n] <- r
  rf_eval$species[n] <- s
  rf_eval$auc[n] <- as.numeric(perf@y.values)
  print(s)
}

mean(rf_eval$auc)
hist(rf_eval$auc)

# auc mean for region
rf_eval %>% 
  group_by(region) %>% 
  summarise(mean(auc))

```


## Creating target group background (TGB) sample

### Introduction

This gives an example for one region, NSW, for creating target group background (TGB) samples. We chose NSW because it has several groups of species, so is one of the more complex examples. 

The main thing to understand here is that for TGB samples the intention is to create a sample consistent with protocols used for the presence records. So, for example, if you had cleaned presence records so there was only one record for each unique location, you would also screen the TGB samples in the same way. 

For these NCEAS data, the presence-only records were cleaned (per species) to one per grid cell. When making the TGB sample (e.g. for birds) a naïve approach would be to simply gather all the records for birds, and use those as a TGB sample. This would not be correct. You may have multiple records in any one cell (e.g. because a recorder may have gone to that location and recorded several species). The idea is to represent survey effort, and the survey effort is not a lot greater for recording many species at one location (or in this case, in one cell). Hence we will reduce the set of records for any designated "group" to one record per grid cell. 

To do this, you will need to download the rasters from OSF – see the link in the first reference below - see the /data/Environment folder. You can download all rasters at once by highlighting the "Environment" folder and clicking "Download as zip".

### TGB example

The code below assumes you have set your working directory, and the environmental rasters are in a sub-folder "env_grids", with the rasters for each region within their respective regional folders

Load the required packages:
```{r warning=F, message=F}
library(terra)
```

Read in the data for NSW:
```{r eval=F}
po <- disPo("NSW")
nsw.raster <- rast("env_grids/nsw/mi.tif")
```

Check how many groups and records in these PO data, and think about what target groups to propose. Here there are 8 groups (see main paper), but it is sensible to collapse some of these, given the way that recorders are likely to survey. Following Phillips *et al.* (2009) we propose four target groups: bat, bird, plant, reptile:

```{r message=F, eval=F, collapse=T}
table(po$group)
target.groups <- list("bat"= "ba", "bird"= c("db", "nb"), "plant"= c("ot", "ou", "rt", "ru"), "reptile"= "sr") 
```

Now, for each target group, extract the relevant rows of data, find which cell each record is in, then identify and remove the duplicates:
```{r warning=F, message=F, eval=F}
tgb.data <- list()

for(i in 1:4){
  getgroup <- match(po$group, target.groups[[i]])
  dat <- po[!is.na(getgroup),]
  samplecellID <- cellFromXY(nsw.raster,dat[,c("x","y")]) 
  dup <- duplicated(samplecellID)
  tgb.data[[i]] <- dat[!dup,]
}

names(tgb.data) <- names(target.groups)
```

## References
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E. (2020) Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics, 15, 69-80.

Phillips, S.J., Dudík, M., Elith, J., Graham, C.H., Lehmann, A., Leathwick, J. & Ferrier, S. (2009) Sample selection bias and presence-only distribution models: implications for background and pseudo-absence data. Ecological Applications, 19, 181–197.

\name{disCRS}

\alias{disCRS}
 
\title{
Coordinate reference system
}

\description{
Get the coordinate reference system for the data of a region.  
}

\usage{
disCRS(region, format="proj4")
}
 
\arguments{
  \item{region}{character. One of "AWT", "CAN", "NSW", "NZ", "SA", "SWI" }

  \item{format}{character. Either "proj4" or "EPSG"}
}


\value{
character vector
}

\examples{
disCRS("AWT")
disCRS("NSW")
}

\keyword{data}
\keyword{spatial}

\name{disPredictors}

\alias{disPredictors}

\title{
Predictor variables
}

\description{
Get the names of the predictor variables for a region.
}

\usage{
disPredictors(region)
}

\arguments{
  \item{region}{character. One of "AWT", "CAN", "NSW", "NZ", "SA", "SWI" }
}


\value{
character vector
}


\examples{
disPredictors("NSW")
}

\keyword{data}

\name{disMapBook}
\alias{disMapBook}

\title{
Generating maps of disdat species
}

\description{
A helper function for automatically generating maps for the species data in PDF format.
}

\usage{
disMapBook(region, output_pdf, verbose = TRUE)
}


\arguments{
  \item{region}{
 A character vector. The name of the region(s) to generate plots.
}
  \item{output_pdf}{
 Output pdf file to be saved.
}
  \item{verbose}{
 Logical. control amount of screen reporting.
}

}


\seealso{
\code{\link{disPo}}, \code{\link{disPa}} and \code{\link{disBorder}}
}


\examples{\donttest{
disMapBook(c("AWT", "NSW"), file.path(tempdir(), "sp_mapbook.pdf"))
}
}

\keyword{map}
\keyword{spatial}

\name{SWI}

\alias{SWI}

\docType{data}

\title{Swiss species distribution data}

\description{
Species occurrence data for 30 tree species in Switzerland (SWI, a country in Europe) and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group (tree), and site values for 13 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to \code{po}, with "0" for occurrence (not implying absence, but denoting background in a way suited to most modelling methods) and \code{NA} for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 13 environmental variables (below), at 10103 sites. This file is suited to making predictions.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species. The sites are identical to the sites in \code{env}. This file is suited to evaluating the predictions made to \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The reference system of the x and y coordinates is Transverse, spheroid Bessel  (EPSG:21781) (note all SWI data has a constant shift applied).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.

\strong{Environmental variables:}
\tabular{llll}{
\strong{Code} \tab \strong{Description} \tab \strong{Units} \tab \strong{Type} \cr

 bcc  \tab  Broadleaved continuous cover  (based on Landsat images)  \tab  percentage  \tab  Continuous \cr
calc  \tab  Bedrock is strictly calcareous  \tab 1 (yes) or 0 (no)  \tab  Categorical  \cr
ccc  \tab  Coniferous continuous cover  (based on Landsat images) \tab  percentage   \tab  Continuous  \cr

ddeg  \tab  Growing degree-days above a threshold of 0 degrees C  \tab  degrees C * days  \tab  Continuous   \cr

nutri  \tab  Soil nutrients index between 0-45  \tab  D mval/cm2  \tab  Continuous   \cr

pdsum  \tab  Number of days with rainfall higher than 1 mm   \tab  ndays  \tab  Continuous   \cr

precyy  \tab  Average yearly precipitation sum   \tab  mm  \tab  Continuous   \cr

sfro  \tab  Summer Frost Frequency \tab  days  \tab  Continuous   \cr

slope \tab  Slope  \tab  degrees x 10  \tab  Continuous   \cr

sradyy  \tab  Potential yearly global radiation (daily average)   \tab  (kJ/m2)/day  \tab  Continuous   \cr

swb  \tab  Site water balance  \tab  mm  \tab  Continuous   \cr

tavecc  \tab  Average temperature of the coldest month   \tab  degrees C  \tab  Continuous   \cr

topo  \tab  Topographic position  \tab  dimensionless   \tab  Continuous   \cr
}
}


\source{
Environmental predictors supplied by Niklaus E. Zimmermann. Species data supplied by Niklaus E. Zimmermann, Thomas Wohlgemuth and Meinrad Abegg.

See the reference below for further details on source, accuracy, cleaning, and particular characteristics of these datasets.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}


\examples{
swi_po <- disPo("SWI")
swi_bg <- disBg("SWI")

swi_pa <- disPa("SWI")
swi_env <- disEnv("SWI")

x <- disData("SWI")
sapply(x, head)

disCRS("SWI")
}


\keyword{datasets}

\name{NSW}

\alias{NSW}


\docType{data}

\title{New South Wales species distribution data}

\description{
Species occurrence data for 54 species from 8 biological groups in New South Wales (NSW, a state in Australia) and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group [ba = bats (7 species); db = diurnal birds (8 species); nb = nocturnal birds (2 species); ot = open-forest trees (8 species); ou = open-forest understorey plants (8 species); rt = rainforest trees (7 species); ru = rainforest understorey plants (6 species); sr = small reptiles (8 species)], and site values for 13 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to \code{po}, with "0" for occurrence (not implying absence, but denoting a background record in a way suited to most modelling methods) and \code{NA} for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 13 environmental variables (below). These are for sites from different surveys for each biological group (from 570 to 2075 sites per group), and can be returned as separate datasets by \code{disEnv}, or in one long format dataset by \code{disData}. This set of files is suited to making predictions.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species (in the wide format returned by \code{disPa}). They can also be returned in long format using \code{disData}. The sites are identical to the sites in \code{env}. These data are suited to evaluating the predictions made with \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The reference system of the x and y coordinates is unprojected. Latitude and longitude are in geographical coordinates using the WGS84 datum (EPSG:4326).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.

\strong{Environmental variables:}
\tabular{llll}{
\strong{Code} \tab \strong{Description} \tab \strong{Units} \tab \strong{Type} \cr

cti      \tab "compound topographic index" - a quantification of the position of a site in the local landscape. It is often referred to as the steady state wetness index and it is defined as: CTI = ln ( As / tanB ) where 'As' is the specific catchment area expressed as m2 per unit width orthogonal to the flow direction and 'B' is the slope angle \tab \tab Continuous\cr

disturb  \tab disturbance (clearing, logging etc) index. \tab 1 = light, 2 = moderate, 3 = heavy \tab Continuous\cr

mi        \tab moisture index. Index of site wetness derived from a water balance algorithm using rainfall, evaporation, radiation and soil depth as inputs \tab Between 0 (dry) and 100 (wet) \tab Continuous \cr

rainann \tab mean annual rainfall  \tab mm \tab Continuous \cr

raindq    \tab mean rainfall of the driest quarter  \tab mm        \tab Continuous  \cr

rugged    \tab ruggedness. Coefficient of variation of grid cells within 1km of cell of interest \tab percent \tab Continuous \cr

soildepth \tab mean soil depth predicted from a model relating sampled soil depths to climate, geology and topography \tab m * 1000 \tab Continuous \cr

soilfert  \tab soil fertility ordinal class, derived from soil maps and modeling of geochemical data \tab  1 (low) to 5 (high) \tab Continuous \cr

solrad    \tab annual mean solar radiation (terrain adjusted)      \tab MJm^-2day^-1 * 10 \tab Continuous \cr

tempann   \tab annual mean temperature              \tab degrees C * 10     \tab Continuous   \cr

tempmin   \tab minimum temperature of the coldest month \tab degrees C * 10 \tab Continuous \cr

topo      \tab topographic position. Mean difference in elevation between grid cell of interest and all cells within 1km radius (-ve values are gullies, +ve are ridges) \tab m \tab Continuous\cr

vegsys   \tab broad vegetation type \tab 1 = Rainforest, 2 = Moist open forest, 3 = Dry open forest, 4 = Woodland, 5 = Coastal sclerophyll complex, 6 = Plateau sclerophyll complex, 7 = Disturbed remnant, 8 = Exotic (pine) plantation, 9 = Cleared \tab Categorical \cr
}
}


\source{
All data were compiled and provided by Simon Ferrier and colleagues.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}


\examples{
nsw_po <- disPo("NSW")
nsw_bg <- disBg("NSW")

nsw_pa_bat <- disPa("NSW", "ba")
nsw_env_bat <- disEnv("NSW", "ba")
nsw_pa_reptile <- disPa("NSW", "sr")
nsw_env_reptile <- disEnv("NSW", "sr")


# Or all in one list
nsw <- disData("NSW")
sapply(nsw, head)

disCRS("NSW")
}

\keyword{datasets}

\name{NZ}

\alias{NZ}

\docType{data}

\title{New Zealand species distribution data}

\description{
Species occurrence data for 52 vascular plant species - mostly trees and shrubs from indigenous forests -  in New Zealand (NZ), and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group (plant), and site values for 13 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to \code{po}, with "0" for occurrence (not implying absence, but denoting a background record in a way suited to most modelling methods) and \code{NA} for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 13 environmental variables (below), at 19120 sites. These data are suited to making predictions.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species. The sites are identical to the sites in \code{env}. This file is suited to evaluating the predictions made to \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The coordinate reference system of the x and y coordinates is New Zealand Map Grid (NZMG), Datum: NZGD49 (New Zealand Geodetic Datum 1949), Ellipsoid: International 1924 (EPSG:27200).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.

\strong{Environmental variables:}
\tabular{llll}{
\strong{Code} \tab \strong{Description} \tab \strong{Units} \tab \strong{Type} \cr

age  \tab  3 classes (0 to 2): <2000, 2000-postglacial (app. 30,000), and pre-glacial  \tab  number (category)  \tab  Categorical   \cr
deficit  \tab  Mean October vapor pressure deficit at 0900 hours  \tab  kPa  \tab  Continuous   \cr
dem  \tab  Elevation  \tab  meters  \tab  Continuous   \cr
hillshade  \tab  Hill shading (as surrogate for slope and aspect)  \tab  index of brightness  \tab  Continuous   \cr
mas  \tab  Mean annual solar radiation  \tab  Mj/m2/day  \tab  Continuous   \cr
mat  \tab  Mean annual temperature  \tab  degrees C * 10  \tab  Continuous   \cr
r2pet  \tab  Average monthly ratio of rainfall and potential evapotranspiration (ratio)  \tab  none  \tab  Continuous   \cr
rain  \tab  annual precipitation  \tab  mm  \tab  Continuous   \cr
slope  \tab  Slope  \tab  degrees    \tab  Continuous   \cr
sseas \tab Solar radiation seasonality \tab dimensionless \tab Continuous \cr
toxicats  \tab  Toxic Cations in classes: 0=low, 1=intermediate, 2=high   \tab  number (category) \tab  Categorical  \cr
tseas  \tab  Temperature seasonality  \tab  degrees C  \tab  Continuous  \cr
vpd  \tab  Mean October vapor pressure deficit at 9 AM  \tab  kPa  \tab  Continuous  \cr
}

}

\source{
Environmental predictors provided by Jake Overton. Species data supplied by Jake Overton and Susan Wiser, from Allan Herbarium and National Vegetation Survey databank.

See the reference below for further details on source, accuracy, cleaning, and particular characteristics of these datasets.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}

\examples{
nz_po <- disPo("NZ")
nz_bg <- disBg("NZ")

nz_pa <- disPa("NZ")
nz_env <- disEnv("NZ")

x <- disData("NZ")
sapply(x, head)

disCRS("NZ")
}

\keyword{datasets}

\name{CAN}

\alias{CAN}

\docType{data}

\title{Canadian bird species distribution data}

\description{
Species occurrence data for 20 bird species from Ontario, a province in Canada (CAN), and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group (bird), and site values for 11 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to CANtrain_po, with "0" for occurrence (not implying absence, but denoting background in a way suited to most modelling methods) and "NA" for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 11 environmental variables (below), at 14571 sites. This file is suited to making predictions.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species. The sites are identical to the sites in \code{env}. This file is suited to evaluating the predictions made to \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The reference system of the x and y coordinates is unprojected with Clarke 1866 ellipsoid . Latitude and longitude are in geographical coordinates using unknown datum based upon the Clarke 1866 ellipsoid (EPSG:4008).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.

\strong{Environmental variables:}
\tabular{llll}{
\strong{Code} \tab \strong{Description} \tab \strong{Units} \tab \strong{Type} \cr
alt  \tab  Digital elevation   \tab  m  \tab  Continuous \cr
asp2  \tab  Aspect  \tab  ranges from -1 to 1 (sin transformation)  \tab  Continuous \cr
ontprec  \tab  Annual Precipitation  \tab  mm  \tab  Continuous \cr
ontprec4  \tab  April precipitation  \tab  mm  \tab  Continuous \cr
ontprecsd  \tab  Precipitation Seasonality  \tab  dimensionless  \tab  Continuous \cr
ontslp  \tab  Slope   \tab  degrees  \tab  Continuous \cr
onttemp  \tab  Annual mean temperature   \tab  degrees C * 10  \tab  Continuous \cr
onttempsd  \tab  Temperature standard deviation   \tab  dimensionless  \tab  Continuous \cr
onttmin4  \tab  April minimum temperature  \tab  degrees C * 10 \tab  Continuous \cr

ontveg  \tab  Vegetation, from Ontario Land Cover Database (OLC) vegetation map, derived from a mosaic of Landsat images.   \tab  5 classes: 1 = open forest & related; 2 = closed forest; 3 = open water, 4 = agriculture, 5 = human settlement  \tab  Categorical \cr
watdist  \tab  Distance from Hudson Bay  \tab  m  \tab  Continuous \cr
}
}


\source{
Environmental predictors prepared by Falk Huettmann, Jane Elith and Catherine Graham. Species data: PO from the Ontario Nest Records database, Royal Ontario Museum (ROM) and supplied by M. Peck to Falk Huettmann;  PA from Breeding Bird Atlas for Ontario, provided by M. Cadman to Falk Huettmann.

See the reference below for further details on source, accuracy, cleaning, and particular characteristics of these datasets.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}


\examples{
can_po <- disPo("CAN")
can_bg <- disBg("CAN")

can_pa <- disPa("CAN")
can_env <- disEnv("CAN")


# Or all in one list
x <- disData("CAN")
sapply(x, head)

disCRS("CAN")

}

\keyword{datasets}

\name{AWT}

\alias{AWT}

\docType{data}

\title{Australian Wet Tropics species distribution data}

\description{
Species occurrence data for 40 species (20 vascular plants, 20 birds) in the Australian Wet Tropics (AWT) and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group (plant or bird), and site values for 13 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to \code{po}, with "0" for occurrence (not implying absence, but denoting a background record in a way suited to most modelling methods) and \code{NA} for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 13 environmental variables (below). These are for sites from different surveys for plants (102 sites) and birds (340 sites), and can be returned as separate datasets by \code{disEnv}, or in one long format dataset by \code{disData}. These data are suited to make predictions to.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species (in the wide format returned by \code{disPa}). They can also be returned in long format using \code{disData}. The sites are identical to the sites in \code{env}. These data are suited to evaluating the predictions made with \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The coordinate reference system of the x and y coordinates is UTM, zone 55, spheroid GRS 1980, datum GDA94 (EPSG:28355).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.

\strong{Environmental variables:}
\tabular{llll}{
\strong{Code}  \tab \strong{Description}  \tab \strong{Units} \tab \strong{Type}  \cr
bc01  \tab Annual mean temperature    \tab degrees C \tab Continuous  \cr
bc04  \tab Temperature seasonality    \tab dimensionless \tab Continuous  \cr
bc05  \tab Max. temperature of warmest period     \tab degrees C  \tab Continuous  \cr
bc06  \tab Min. temperature of coldest period     \tab  degrees C  \tab Continuous  \cr
bc12  \tab Annual precipitation       \tab mm     \tab  Continuous  \cr
bc15  \tab Precipitation seasonality  \tab dimensionless \tab Continuous  \cr
bc17  \tab Precipitation of driest quarter \tab mm \tab Continuous  \cr
bc20  \tab Annual mean radiation      \tab MJ/m2/day \tab Continuous  \cr
bc31  \tab Moisture index seasonality \tab dimensionless \tab Continuous \cr
bc33  \tab Mean moisture index of lowest quarter (MI) \tab dimensionless \tab Continuous \cr
slope \tab Slope                      \tab percent \tab Continuous \cr
topo  \tab Topographic position       \tab 0 is a gully and 100 a ridge, 50 mid-slope  \tab Continuous \cr
tri   \tab Terrain ruggedness index	  \tab Sum of variation in a 1 km moving window \tab Continuous \cr
}
}


\source{
Environmental predictors prepared by Karen Richardson, Caroline Bruce and Catherine Graham. Species data supplied by Andrew Ford, Stephen Williams and Karen Richardson.

See the reference below for further details on source, accuracy, cleaning, and particular characteristics of these datasets.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}


\examples{
awt_po <- disPo("AWT")
awt_bg <- disBg("AWT")

awt_pa_plant <- disPa("AWT", "plant")
awt_env_plant <- disEnv("AWT", "plant")
awt_pa_bird <- disPa("AWT", "bird")
awt_env_bird <- disEnv("AWT", "bird")


# Or all in one list
awt <- disData("AWT")
sapply(awt, head)

disCRS("AWT")
}

\keyword{datasets}

\name{disdat-package}

\alias{disdat-package}
\alias{disdat}

\docType{package}

\title{
Data for species distribution modeling
}

\description{
This package allows for easy use of a collection of datasets that can be used to compare species distribution models. There are data for 6 regions in the world, for a total of 226 anonymised species including birds, vascular plants, reptiles and bats. Each data set has presence-only (and optionally background) training data to build models, and presence/absence data to evaluate models.

The data were compiled and used by a species distribution modeling working group sponsored by the National Center for Ecological Analysis and Synthesis (NCEAS), at UC Santa Barbara, USA. Full details of the dataset are provided in the first publication listed below, from the NCEAS data group.
}

\details{
The data are fully described in the first publication listed below, and also supplied with metadata on Open Science Framework (OSF). On the OSF site, rasters (gridded data) of all environmental data are also available for download.
}


\author{
Package by Robert J. Hijmans, Roozbeh Valavi, and Jane Elith. Data collation and processing by the NCEAS data group (see first reference below, and the manual package for specific datasets).
}

\references{
The main reference for the these data is:

\itemize{
    \item{Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.}
}


Other papers using these data include:

\itemize{
    \item{Dudík, M. & Phillips, S. J. (2009). Generative and Discriminative Learning with Unknown Labeling Bias. in Advances in Neural Information Processing Systems 21 (eds. Koller, D., Schuurmans, D., Bengio, Y. & Bottou, L.) 401-408. Curran Associates, Inc.}
    \item{Dudík, M., Phillips, S. J. & Schapire, R. E. (2006). Correcting sample selection bias in maximum entropy density estimation. in Advances in Neural Information Processing Systems 18 (eds. Weiss, Y., Schölkopf, B. & Platt, J. C.) 323-330 (MIT Press).}
    \item{Elith, J. & Leathwick, J. R. (2007). Predicting species distributions from museum and herbarium records using multiresponse models fitted with multivariate adaptive regression splines. Diversity and Distributions 13, 165-175.}
    \item{Elith, J., Graham, C.H., Anderson, R.P., Dudík, M., Ferrier, S., Guisan, A., Hijmans, R.J., Huettmann, F., Leathwick, J.R., Lehmann, A., Li, J., Lohmann, L.G., Loiselle, B.A., Manion, G., Moritz, C., Nakamura, M., Nakazawa, Y., Overton, J.McC., Peterson, A.T., Phillips, S.J., Richardson, K.S., Scachetti-Pereira, R., Schapire, R.E., Soberón, J., Williams, S., Wisz, M.S., Zimmermann, N.E. (2006). Novel methods improve prediction of species’ distributions from occurrence data. Ecography 29, 129–151}
    \item{Graham, C.H., Elith, J., Hijmans, R.J., Guisan, A., Peterson, A.T., Loiselle, B.A. (2008). The influence of spatial errors in species occurrence data used in distribution models. Journal of Applied Ecology 45, 239–247.}
    \item{Guisan, A., Graham, C. H., Elith, J., Huettmann, F. & NCEAS Species Distribution Modelling Group (2007). Sensitivity of predictive species distribution models to change in grain size: insights from a multi-models experiment across five continents. Diversity and Distributions 13, 332-340.}
    \item{Guisan, A., Zimmermann, N. E., Elith, J., Graham, C. H., Phillips, S. P., & Peterson, A. T. (2007). What matters for predicting the occurences of trees: techniques, data, or species' characteristics? Ecological Monographs 77, 615-530.}
    \item{Hijmans, R. J. (2012). Cross-validation of species distribution models: removing spatial sorting bias and calibration with a null model. Ecology 93, 679-688.}
    \item{Phillips, S. J. & Dudík, M. (2008). Modeling of species distributions with Maxent: new extensions and a comprehensive evaluation. Ecography 31, 161-175.}
    \item{Phillips, S. J. & Elith, J. (2010). POC-plots: calibrating species distribution models with presence-only data. Ecology 91, 2476-2484.}
    \item{Phillips, S.J., Dudík, M., Elith, J., Graham, C.H., Lehmann, A., Leathwick, J., Ferrier, S. (2009). Sample selection bias and presence-only distribution models: implications for background and pseudo-absence data. Ecological Applications 19, 181–197.}
    \item{Phillips, S. J., Anderson, R. P., Dudík, M., Schapire, R. E. & Blair, M. E. (2017). Opening the black box: an open-source release of Maxent. Ecography 40, 887-893.}
    \item{Valavi, R., Elith, J., Lahoz‐Monfort, J.J. & Guillera‐Arroita, G. (2023). Flexible species distribution modelling methods perform well on spatially separated testing data. Global Ecology and Biogeography, geb.13639.}
    \item{Valavi, R., Elith, J., Lahoz‐Monfort, J.J. & Guillera‐Arroita, G. (2021). Modelling species presence‐only data with random forests. Ecography, 44, 1731–1742.}
    \item{Valavi, R., Guillera‐Arroita, G., Lahoz‐Monfort, J.J. & Elith, J. (2022). Predictive performance of presence‐only species distribution models: a benchmark study with reproducible code. Ecological Monographs, 92(1). 10.1002/ecm.1486}
    \item{Wisz, M.S., Hijmans, R.J., Li, J., Peterson, A.T., Graham, C.H., Guisan, A., & NCEAS Species Distribution Modelling Group (2008). Effects of sample size on the performance of species distribution models. Diversity and Distributions 14, 763–773.}
}

}

\keyword{ package }
\keyword{ spatial }

\name{disData}

\alias{disData}
\alias{disPo}
\alias{disBg}
\alias{disPa}
\alias{disEnv}

\alias{disBorder}

\title{
Get disdat datasets
}

\description{
\code{disPo} returns the presence-only (po) data for a region

\code{disBg} returns the background (bg) data for a region

\code{disPa} returns the presence-absence (pa) data for a region and group

\code{disEnv} returns the environmental (env) data for sites matching those in the pa data, for a region and group

\code{disData} returns a list with all data for a region.

\code{disBorder} returns a polygon for one of the regions.
}


\usage{
disData(region)

disPo(region)

disBg(region)

disPa(region, group)

disEnv(region, group)

disBorder(region, pkg="sf")
}

\arguments{
  \item{region}{character. One of "AWT", "CAN", "NSW", "NZ", "SA", "SWI" }

  \item{group}{character. If \code{region} is \code{"NSW"}, one of "ba", "db", "nb", "ot", "ou", "rt", "ru", "sr". \code{region} is \code{"AWT"} "bird", "plant". The other regions each have only one group, so group should not be specified}

  \item{pkg}{character. Either "sf" or "terra" to get polygons as defined by that package}
}


\details{
\code{disData} returns a list with \code{env}, \code{pa}, \code{bg} and \code{po} data in that order. For regions with more than one group, the testing data (env and pa) will come from different surveys, and the model testing should be targeted to the relevant group. The first column of the \code{env} and \code{pa} data.frames is "group", which can be used to extract the correct data.
}


\value{
data.frame (disPo, disBg, disPa and disEnv) or list with four data.frames (disData)
}


\examples{
awt_po <- disPo("AWT")

awt_bg <- disBg("AWT")

awt_pa_plants <- disPa("AWT", "plant")

awt_env_plants <- disEnv("AWT", "plant")


x <- disData("NSW")

names(x)

sapply(x, head)


z <- disBorder("NSW")

plot(z)

}

\keyword{data}

\name{SA}

\alias{SA}

\docType{data}

\title{South American plant species distribution data}

\description{
Species occurrence data for 30 vascular plant species (all from the Bignoniaceae family) from Continental Brazil, Ecuador, Colombia, Bolivia, and Peru, South America (SA), and associated environmental data. Full details of the dataset are provided in the reference below. There are four data sets with training (po and bg) and test (pa, env) data:

\code{po} (training data) includes site names, species names, coordinates, occurrence ("1" for all, since all are presence records), group (plant), and site values for 11 environmental variables (below).

\code{bg} (training data) has 10000 sites selected at random across the study region. It is structured identically to \code{po}, with "0" for occurrence (not implying absence, but denoting background in a way suited to most modelling methods) and \code{NA} for group.

\code{env} (testing data) includes group, site names, coordinates, and site values for 11 environmental variables (below), at 152 sites. This file is suited to making predictions.

\code{pa} (testing data) includes group, site names, coordinates, and presence-absence records, one column per species. The sites are identical to the sites in \code{env}. This file is suited to evaluating the predictions made to \code{env}.

Raster (gridded) data for all environmental variables are available - see the reference below for details.

The coordinate reference system of the x and y coordinates is longitude, latitude, with the WGS84 datum (EPSG:4326).

The vignette provided with this package provides an example of how to fit and evaluate a model with these data.


\strong{Environmental variables (extracted from WorldClim):}
\tabular{llll}{
\strong{Code} \tab \strong{Description} \tab \strong{Units} \tab \strong{Type} \cr

sabio1  \tab  Annual mean temperature    \tab  degrees C * 10  \tab  Continuous  \cr
sabio2  \tab  Mean Diurnal Range (Mean of monthly (max temp - min temp))  \tab  degrees C * 10  \tab  Continuous  \cr
sabio4  \tab  Temperature Seasonality (standard deviation *100)  \tab  dimensionless  \tab  Continuous  \cr
sabio5  \tab  Max Temperature of Warmest Month  \tab  degrees C * 10  \tab  Continuous  \cr
sabio6  \tab  Min Temperature of Coldest Month  \tab  degrees C * 10  \tab  Continuous  \cr
sabio7  \tab  Temperature Annual Range \tab  degrees C * 10  \tab  Continuous  \cr
sabio8  \tab  Mean Temperature of Wettest Quarter   \tab  mm  \tab  Continuous  \cr
sabio12  \tab  Annual Precipitation  \tab  mm  \tab  Continuous  \cr
sabio15  \tab  Precipitation Seasonality (Coefficient of Variation)  \tab  mm  \tab  Continuous  \cr
sabio17  \tab  Precipitation of Driest Quarter  \tab  mm  \tab  Continuous  \cr
sabio18  \tab  Precipitation of Warmest Quarter  \tab  mm  \tab  Continuous  \cr
}
}


\source{
Environmental data prepared by Bette Loiselle, Lucia Lohmann and Catherine Graham. Species supplied by Bette Loiselle and Lucia Lohmann. PO data from the Missouri Botanical Gardens database and Lucia Lohmann; PA data collected by Al Gentry.

See the reference below for further details on source, accuracy, cleaning, and particular characteristics of these datasets.
}

\references{
Elith, J., Graham, C.H., Valavi, R., Abegg, M., Bruce, C., Ferrier, S., Ford, A., Guisan, A., Hijmans, R.J., Huettmann, F., Lohmann, L.G., Loiselle, B.A., Moritz, C., Overton, J.McC., Peterson, A.T., Phillips, S., Richardson, K., Williams, S., Wiser, S.K., Wohlgemuth, T. & Zimmermann, N.E., (2020). Presence-only and presence-absence data for comparing species distribution modeling methods. Biodiversity Informatics 15:69-80.
}


\examples{
sa_po <- disPo("SA")
sa_bg <- disBg("SA")

sa_pa <- disPa("SA")
sa_env <- disEnv("SA")

x <- disData("SA")
sapply(x, head)

disCRS("SA")
}

\keyword{datasets}
